#include <pic.h>

#define KEYPRESSED() ((~(PORTB>>3))&0x7)

#define BCDINC(x) { \
					++x; \
					if ((x&0xF)==0xA) { \
						x=(x+0x10)&0xF0; \
					} \
				}

typedef unsigned char byte;
typedef unsigned int  uint;
typedef char bool;


__CONFIG(0x3FF1); // 1111111111.0.0.01 b


struct {
	byte day, month, year, h, m, s;
} vrijeme;

struct {
	byte row1, row2, row3;
} display;

byte ticks=0;
byte mode=0;

void interrupt prv_int() {
	if (!T0IF) return;	/* maknuti?!*/
	T0IF=0;

	if (++ticks==15) {
		BCDINC(vrijeme.s);
		ticks=0;
	}
}

void Display(byte data, byte rowmask) {
	byte a;
	for (a=0;a!=8;++a) {
		PORTA=0;
		PORTB=a;
		PORTA=(data&1)?rowmask:0;
		data>>=1;
	}
}

void TimeCalc() {
	if (vrijeme.s==0x60) {
		vrijeme.s=0x00;
		BCDINC(vrijeme.m);
		if (vrijeme.m==0x60) {
			vrijeme.m=0x00;
			BCDINC(vrijeme.h);
			if (vrijeme.h==0x13)
				vrijeme.h=0x00;
		}
	}
}

void Think() {
	byte key=0, keyt;
	while (keyt=KEYPRESSED())key=keyt;
		TimeCalc();
	
	/*switch (mode) {
	}*/
	if (key&1) {
		BCDINC(vrijeme.h);
	}
	if (key&2) {
		BCDINC(vrijeme.m);
	}
	if (key&4) {
		BCDINC(vrijeme.s);
	}
}

void main () {
	TRISB = 0xF8; //0=output
	TRISA = 0x00;
	RBPU = 0;	// enable pullups

	PS0 = 1;
	PS1 = 1;
	PS2 = 1;
	PSA = 0;		/* preskaler se dodijeljuje Timeru (1 = Watchdog)*/
			/* za svaki TImer0=FF generira se T0IF */
	T0CS = 0;		/* Ukljucen Timer mode*/

	INTCON = 0;
	GIE = 1;
	T0IE = 1;

	
	PORTB = 0;
	PORTA = 1;

	vrijeme.h=1;
	vrijeme.m=0;
	vrijeme.s=0;

	vrijeme.day=7;
	vrijeme.month=11;
	vrijeme.year=6;

	PORTA = 0;
	
	for(;;) {
		TimeCalc();

		Think();
		
		display.row1=vrijeme.h;
		display.row2=vrijeme.m;
		display.row3=vrijeme.s;

		/* prikaz */
		Display(display.row1, 1);
		Display(display.row2, 2);
		Display(display.row3, 4);
	}
} /* main */

